import { RPCError } from './RPCError';
import { RPCMessage } from '../core/type';

export interface RPCClientCodec {
  request(method: string, args: any[], id: number): RPCMessage;
  response(message: RPCMessage): RPCClientResponseCodec;
}

export interface RPCClientResponseCodec {
  id(): number | undefined;
  error(): RPCError | undefined;
  result(): any | undefined;

  isNotification(): boolean;
  notification(): RPCClientNotificationCodec | undefined;
}

export interface RPCClientNotificationCodec {
  method(): string;
  params(): any | undefined;
}
