import { Injectable, Inject } from '@angular/core';

import {
  RPC_CODEC,
  RPC_RWC,
} from '../core/token';

import { RPCClient } from '../client/RPCClient';
import { RPCClientRWC } from '../client/RPCClientRWC';
import { RPCClientCodec, RPCClientNotificationCodec } from '../protocol/RPCClientCodec';

import {
  RPCSubscribeService,
} from '../subscribe/subscribe.service';

@Injectable()
export class RPCService extends RPCClient {
  constructor(
    @Inject(RPC_CODEC) rpcClientCodec: RPCClientCodec,
    @Inject(RPC_RWC) rpcClientRWC: RPCClientRWC,
    private rpcSubscribeService: RPCSubscribeService,
  ) {
    super(rpcClientCodec, rpcClientRWC);
  }

  protected onNotification(notiCodec: RPCClientNotificationCodec): void {
    this.rpcSubscribeService.notify(notiCodec);
  }
}
